<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 06/19/2004 *
 * ================                             Last change: 12/26/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-rallye.php                                   *
 * -------------------------------------------------------------------- *
 * Short description : Referal rallye                                   *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Ref-Rallyes starten                              *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Version number
$EXT_VERSION = "0.3.4";

// Auto-set extension version
if (empty($EXT_VER)) $EXT_VER = $EXT_VERSION;

// Version history array (add more with , "0.1" and so on)
$EXT_VER_HISTORY = array("0.0", "0.0.1", "0.0.2", "0.0.3", "0.0.4", "0.0.5", "0.0.6", "0.0.7", "0.0.8", "0.0.9", "0.1.0", "0.1.1", "0.1.2", "0.1.3", "0.1.4", "0.1.5", "0.1.6", "0.1.7", "0.1.8", "0.1.9", "0.2.0", "0.2.1", "0.2.2", "0.2.3", "0.2.4", "0.2.5", "0.2.6", "0.2.7", "0.2.8", "0.2.9", "0.3.0", "0.3.1", "0.3.2", "0.3.3", "0.3.4");

switch ($EXT_LOAD_MODE)
{
case "register": // Do stuff when installation is running (modules.php?module=admin&action=login is called)
	// SQL commands to run
	$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_rallye_data";
	$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_rallye_prices";
	$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_rallye_users";
	$SQLs[] = "CREATE TABLE "._MYSQL_PREFIX."_rallye_data (
id BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
admin_id BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
title VARCHAR(255) NOT NULL DEFAULT '',
descr LONGBLOB NOT NULL,
template VARCHAR(255) NOT NULL DEFAULT '',
start_time VARCHAR(10) NOT NULL DEFAULT 0,
end_time VARCHAR(10) NOT NULL DEFAULT 0,
auto_add_new_user ENUM('Y','N') NOT NULL DEFAULT 'Y',
is_active ENUM('Y','N') NOT NULL DEFAULT 'N',
send_notify ENUM('Y','N') NOT NULL DEFAULT 'Y',
notified ENUM('Y','N') NOT NULL DEFAULT 'N',
KEY (admin_id),
PRIMARY KEY (id)
) TYPE=MyISAM";
	$SQLs[] = "CREATE TABLE "._MYSQL_PREFIX."_rallye_prices (
id BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
rallye_id BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
price_level BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
points BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
info LONGBLOB NOT NULL,
KEY (rallye_id),
PRIMARY KEY(id)
) TYPE=MyISAM";
	$SQLs[] = "CREATE TABLE "._MYSQL_PREFIX."_rallye_users (
id BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
rallye_id BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
userid BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
refs BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
KEY (rallye_id),
KEY (userid),
PRIMARY KEY(id)
) TYPE=MyISAM";
	// Admin menu
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (`action`,`what`,`title`,`descr`,`sort`) VALUES ('rallye', NULL, 'Rallye-Management','Richten Sie neue Ref-Rallyes ein, die zeitgesteuert anfangen und aufh&ouml;hren. Dabei wird alles weitere automatisch geregelt.','9')";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (`action`,`what`,`title`,`descr`,`sort`) VALUES ('rallye','add_rallye','Neue Rallye hinzuf&uuml;gen','Neue Ref-Rallye hinzuf&uuml;gen.','1')";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (`action`,`what`,`title`,`descr`,`sort`) VALUES ('rallye','config_rallye_prices','Preise einrichten','Richten Sie Preise zu den Rallyes ein.','2')";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (`action`,`what`,`title`,`descr`,`sort`) VALUES ('rallye','list_rallyes','Rallyes verwalten','Alle bestehenden Ref-Rallyes auflisten, bearbeiten, stoppen, l&ouml;schen usw.','3')";
	// Guest menu
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_guest_menu (`action`,`what`,`title`,`visible`,`locked`,`sort`) VALUES ('main','rallyes','Ref-Rallyes','Y','Y','9')";
	// Member menu
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_member_menu (`action`,`what`,`title`,`visible`,`locked`,`sort`) VALUES ('main','rallyes','Ref-Rallyes','Y','Y','9')";
	break;

case "remove": // Do stuff when removing extension
	// SQL commands to run
	$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_rallye_data";
	$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_rallye_prices";
	$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_rallye_users";
	$SQLs[] = "DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_admin_menu WHERE action='rallye' LIMIT 4";
	$SQLs[] = "DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_guest_menu WHERE what='rallyes' LIMIT 1";
	$SQLs[] = "DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_member_menu WHERE what='rallyes' LIMIT 1";
	break;

case "activate": // Do stuff when admin activates this extension
	// SQL commands to run
	$SQLs[] = "UPDATE "._MYSQL_PREFIX."_guest_menu SET visible='Y', locked='N' WHERE what='rallyes' LIMIT 1";
	$SQLs[] = "UPDATE "._MYSQL_PREFIX."_member_menu SET visible='Y', locked='N' WHERE what='rallyes' LIMIT 1";
	break;

case "deactivate": // Do stuff when admin deactivates this extension
	// SQL commands to run
	$SQLs[] = "UPDATE "._MYSQL_PREFIX."_guest_menu SET visible='N', locked='Y' WHERE what='rallyes' LIMIT 1";
	$SQLs[] = "UPDATE "._MYSQL_PREFIX."_member_menu SET visible='N', locked='Y' WHERE what='rallyes' LIMIT 1";
	break;

case "update": // Update an extension
	switch ($EXT_VER)
	{
	case "0.0.1": // SQL queries for v0.0.1
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_rallye_data ADD expired ENUM('Y','N') NOT NULL DEFAULT 'N'";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Ablaufen der Rallyes intergriert.";
		break;

	case "0.0.2": // SQL queries for v0.0.2
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_rallye_users ADD curr_points FLOAT(20,5) UNSIGNED NOT NULL DEFAULT 0.00000";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Aktueller {!POINTS!}-Stand wird beachtet.";
		break;

	case "0.0.6": // SQL queries for v0.0.6
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Fehler <I>Unknown column 'd.useid' in 'on clause'</I> behoben.";
		break;

	case "0.0.7": // SQL queries for v0.0.7
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Fehlende Abfrage im Mitlieder-Modul, on Erweiterung auch aktiviert ist.";
		break;

	case "0.0.8": // SQL queries for v0.0.8
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Fehler <U>Template nicht gefunden</U> behoben und Admin-Formulare ausgelagert";
		break;

	case "0.0.9": // SQL queries for v0.0.9
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist. Und der vorherige Fehler <U>Template nicht gefunden</U> ist endlich beseitigt.";
		break;

	case "0.1.0": // SQL queries for v0.2.1
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_rallye_users CHANGE curr_points curr_points FLOAT(23,5) UNSIGNED NOT NULL DEFAULT 0.00000";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "5 Nachkommastellen implementiert.";
		break;

	case "0.1.1": // SQL queries for v0.1.1
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.";
		break;

	case "0.1.2": // SQL queries for v0.1.2
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Problem mit Speicherung der Einstellungen beseitigt.";
		break;

	case "0.1.3": // SQL queries for v0.1.3
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Anzeigefehler im Gast-/Mitgliedsbereich behoben.";
		break;

	case "0.1.4": // SQL queries for v0.1.4
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Admin-Mails korregiert.";
		break;

	case "0.1.5": // SQL queries for v0.1.5
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Men&uuml;punkte im Gast-/Mitgliedsbereich k&ouml;nnen nicht mehr aufgerufen werden, wenn die Erweiterung deaktiviert ist.";
		break;

	case "0.1.6": // SQL queries for v0.1.6
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Seit <A href=\"#\">Patch 340</A> &uuml;berfl&uuml;ssige HTML-Tags entfernt.";
		break;

	case "0.1.7": // SQL queries for v0.1.7
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Aktivierte bzw. abgelaufene Rallyes werden nur ausserhalb des CSS-Modus geladen (wenn also nicht css.php aufgerufen wurde)";
		break;

	case "0.1.8": // SQL queries for v0.1.8
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Weitere Templates vom Admin-Bereich ausgelagert und Referal-Anazahl in der Mail zur Rallye-Ank&uuml;ndigung repariert.";
		break;

	case "0.1.9": // SQL queries for v0.1.9
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Funktion ADMIN_USER_PROFILE_LINK() mit Verlinkung auf Referal-Liste implementiert.";
		break;

	case "0.2.0": // SQL queries for v0.2.0
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_rallye_data ADD min_users BIGINT(20) UNSIGNED NOT NULL DEFAULT 0";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_rallye_data ADD min_prices BIGINT(20) UNSIGNED NOT NULL DEFAULT '3'";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Ablaufen der Rallyes intergriert. Bauen Sie in Ihr Template <STRONG>templates/de/emails/member/member_rallye_notify.tpl</STRONG> folgende zwei Zeilen ein:<br />
<UL>
  <LI>&#36;DATA&#91;min_users&#93;</LI>
  <LI>&#36;DATA&#91;min_prices&#93;</LI>
</UL>
Zudem sollten Sie mindestens folgende Templates (in <STRONG>templates/".GET_LANGUAGE()."/html/guest/</STRONG> !) aktualisieren:<br />
<UL>
  <LI><STRONG>guest_rallye_footer.tpl</STRONG></LI>
  <LI><STRONG>guest_rallye_header.tpl</STRONG></LI>
</UL>";
		break;

	case "0.2.1": // SQL queries for v0.2.1
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "W&ouml;rter <STRONG>Mailtausch</STRONG>, <STRONG>Mailtausches</STRONG> und <STRONG>Mailtauscher</STRONG> sind austauschbar.";
		break;

	case "0.2.2": // SQL queries for v0.2.2
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Links wegen <STRONG>what=admins_contct</STRONG> ge&auml;ndert.";
		break;

	case "0.2.3": // SQL queries for v0.2.3
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "HTML-Code ausgelagert in Templates und SQL-Anweisungen abgesichert.";
		break;

	case "0.2.4": // SQL queries for v0.2.4
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Abspeichern von Einstellungen repariert.";
		break;

	case "0.2.5": // SQL queries for v0.2.5
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Men&uuml;punkt &quot;Rallyes verwalten&quot; repariert.";
		break;

	case "0.2.6": // SQL queries for v0.2.6
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Automatisches Starten von Referal-Rallyes repariert.";
		break;

	case "0.2.7": // SQL queries for v0.2.7
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Fatalen Fehler beseitigt.";
		break;

	case "0.2.8": // SQL queries for v0.2.8
		// Update notes (these will be set as task text!)

		$UPDATE_NOTES = "Vorbereitung auf die neue Mediendaten v0.0.4.";
		break;

	case "0.2.9": // SQL queries for v0.2.9
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Sicherheitsupdate f&uuml;r die Include-Befehle.";
		break;

	case "0.3.0": // SQL queries for v0.3.0
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "if-Anweisungen auf Funktion <STRONG>empty()</STRONG> umgestellt.";
		break;

	case "0.3.1": // SQL queries for v0.3.1
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Erweiterung f&uuml;r automatisch generierte Admin-Kontaktlinks ge&auml;ndert.";
		break;

	case "0.3.2": // SQL queries for v0.3.2
		$SQLs[] = "UPDATE "._MYSQL_PREFIX."_member_menu SET action='rals', sort='1', title='Referal-Rallye' WHERE what='rallyes' LIMIT 1";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Mitgliedsmen&uuml; komplett umgebaut.";
		break;

	case "0.3.3": // SQL queries for v0.3.3
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Rallyes werden nun nur dann automatisch beseitigt, wenn die Erweiterung <strong>autopurge</strong> installiert und aktiviert ist.";
		break;

	case "0.3.4": // SQL queries for v0.3.4
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Fehlerhinweis bei deaktivierter Erweiterung verbessert.";
		break;
	}
	break;

default: // Do stuff when extension is loaded
	// Do stuff only when not in CSS mode
	if (($CSS != "1") && ($CSS != "-1") && ($cacheMode != "init")) {
		// Get total member count
		$TOTAL = GET_TOTAL_DATA("CONFIRMED", "user_data", "userid", "status", true);

		// Add more data on higher versions
		$ADD1 = ""; $ADD2 = ""; $OR = "";
		if (GET_EXT_VERSION("rallye") >= "0.2.0") {
			$ADD1 = ", min_users, min_prices";
			$ADD2 = ", d.min_users, d.min_prices";
			$OR   = " OR (d.min_users <= ".$TOTAL." AND d.min_users > 0)";
		} // END  - if

		// Check for new started but not notified rallyes
		$result = SQL_QUERY("SELECT SQL_SMALL_RESULT id, title, start_time, end_time, send_notify".$ADD1."
FROM "._MYSQL_PREFIX."_rallye_data
WHERE is_active='Y' AND notified='N' AND expired='N' AND start_time <= UNIX_TIMESTAMP() AND end_time > UNIX_TIMESTAMP()
LIMIT 1", __FILE__, __LINE__);
		if (SQL_NUMROWS($result) == 1) {
			// Start rallye
			RALLYE_AUTOSTART_RALLYES($result);
		} // END - if

		// Free memory
		SQL_FREERESULT($result);

		// Check for expired rallyes
		$result = SQL_QUERY("SELECT SQL_SMALL_RESULT d.id, d.title, d.start_time, d.end_time, d.send_notify".$ADD2."
FROM "._MYSQL_PREFIX."_rallye_data AS d
WHERE d.is_active='Y' AND d.notified='Y' AND d.expired='N' AND (d.end_time <= UNIX_TIMESTAMP()".$OR.")
LIMIT 1", __FILE__, __LINE__);
		if ((SQL_NUMROWS($result) == 1) && (EXT_IS_ACTIVE("autopurge")))
		{
			// End rallye here...
			RALLYE_EXPIRE_RALLYES($result);
		}

		// Free memory
		SQL_FREERESULT($result);
	}
	break;
}

//
?>
