<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 01/09/2005 *
 * ================                             Last change: 01/09/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-beg.php                                     *
 * -------------------------------------------------------------------- *
 * Short description : Beg points with us!                              *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Mit uns Punkte erbetteln!                        *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
} elseif (!EXT_IS_ACTIVE("beg")) {
	ADD_FATAL(EXTENSION_PROBLEM_EXT_INACTIVE, "beg");
	return;
}

// Add description as navigation point
ADD_DESCR("guest", __FILE__);

// Prepare constants
define('__BEG_POINTS'    , TRANSLATE_COMMA($_CONFIG['beg_points']));
define('__BEG_POINTS_MAX', TRANSLATE_COMMA($_CONFIG['beg_points_max']));
if ($GLOBALS['refid'] > 0) {
	// Take referal ID from URL/Cookie
	define('__BEG_UID'       , $GLOBALS['refid']);
} else {
	// Take default referal ID
	define('__BEG_UID'       , $_CONFIG['def_refid']);
}

if (function_exists('CREATE_FANCY_TIME')) {
	define('__BEG_TIMEOUT'    , CREATE_FANCY_TIME($_CONFIG['beg_timeout']));
	define('__BEG_UID_TIMEOUT', CREATE_FANCY_TIME($_CONFIG['beg_uid_timeout']));
} else {
	define('__BEG_TIMEOUT '   , round($_CONFIG['beg_timeout']     / 60)." ".MINUTES);
	define('__BEG_UID_TIMEOUT', round($_CONFIG['beg_uid_timeout'] / 60)." ".MINUTES);
}

// Load final template
LOAD_TEMPLATE("guest_".substr(basename(__FILE__), 5, -4));

//
?>
